/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreTranslationKey.TCoreTranslationKeyPath;
import de.ship.db.tables.records.TCoreElementtypeRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreElementtype extends TableImpl<TCoreElementtypeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_elementtype</code>
     */
    public static final TCoreElementtype T_CORE_ELEMENTTYPE = new TCoreElementtype();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreElementtypeRecord> getRecordType() {
        return TCoreElementtypeRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_elementtype.pk_core_elementtype</code>.
     */
    public final TableField<TCoreElementtypeRecord, Integer> PK_CORE_ELEMENTTYPE = createField(DSL.name("pk_core_elementtype"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_elementtype.key_element_type</code>. id
     */
    public final TableField<TCoreElementtypeRecord, Integer> KEY_ELEMENT_TYPE = createField(DSL.name("key_element_type"), SQLDataType.INTEGER.nullable(false), this, "id");

    /**
     * The column <code>common_dd.t_core_elementtype.name</code>.
     */
    public final TableField<TCoreElementtypeRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_core_elementtype.description</code>.
     */
    public final TableField<TCoreElementtypeRecord, String> DESCRIPTION = createField(DSL.name("description"), SQLDataType.CLOB.nullable(false).defaultValue(DSL.field(DSL.raw("'add description here'::text"), SQLDataType.CLOB)), this, "");

    /**
     * The column <code>common_dd.t_core_elementtype.elementtype_lang</code>.
     * foreign key to lang_key
     */
    public final TableField<TCoreElementtypeRecord, String> ELEMENTTYPE_LANG = createField(DSL.name("elementtype_lang"), SQLDataType.CLOB.nullable(false), this, "foreign key to lang_key");

    /**
     * The column <code>common_dd.t_core_elementtype.lastchange</code>.
     */
    public final TableField<TCoreElementtypeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    private TCoreElementtype(Name alias, Table<TCoreElementtypeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreElementtype(Name alias, Table<TCoreElementtypeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_elementtype</code> table
     * reference
     */
    public TCoreElementtype(String alias) {
        this(DSL.name(alias), T_CORE_ELEMENTTYPE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_elementtype</code> table
     * reference
     */
    public TCoreElementtype(Name alias) {
        this(alias, T_CORE_ELEMENTTYPE);
    }

    /**
     * Create a <code>common_dd.t_core_elementtype</code> table reference
     */
    public TCoreElementtype() {
        this(DSL.name("t_core_elementtype"), null);
    }

    public <O extends Record> TCoreElementtype(Table<O> path, ForeignKey<O, TCoreElementtypeRecord> childPath, InverseForeignKey<O, TCoreElementtypeRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_ELEMENTTYPE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreElementtypePath extends TCoreElementtype implements Path<TCoreElementtypeRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreElementtypePath(Table<O> path, ForeignKey<O, TCoreElementtypeRecord> childPath, InverseForeignKey<O, TCoreElementtypeRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreElementtypePath(Name alias, Table<TCoreElementtypeRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreElementtypePath as(String alias) {
            return new TCoreElementtypePath(DSL.name(alias), this);
        }

        @Override
        public TCoreElementtypePath as(Name alias) {
            return new TCoreElementtypePath(alias, this);
        }

        @Override
        public TCoreElementtypePath as(Table<?> alias) {
            return new TCoreElementtypePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreElementtypeRecord, Integer> getIdentity() {
        return (Identity<TCoreElementtypeRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreElementtypeRecord> getPrimaryKey() {
        return Keys.PK_ELEMENTTYPE;
    }

    @Override
    public List<ForeignKey<TCoreElementtypeRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_ELEMENTTYPE__FK_ELEMENTTYPE_LANG);
    }

    private transient TCoreTranslationKeyPath _tCoreTranslationKey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_translation_key</code> table.
     */
    public TCoreTranslationKeyPath tCoreTranslationKey() {
        if (_tCoreTranslationKey == null)
            _tCoreTranslationKey = new TCoreTranslationKeyPath(this, Keys.T_CORE_ELEMENTTYPE__FK_ELEMENTTYPE_LANG, null);

        return _tCoreTranslationKey;
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, null, Keys.T_CORE_ELEMENT_HIERARCHY__FK_KEY_ELEMENT_TYPE.getInverseKey());

        return _tCoreElementHierarchy;
    }

    @Override
    public TCoreElementtype as(String alias) {
        return new TCoreElementtype(DSL.name(alias), this);
    }

    @Override
    public TCoreElementtype as(Name alias) {
        return new TCoreElementtype(alias, this);
    }

    @Override
    public TCoreElementtype as(Table<?> alias) {
        return new TCoreElementtype(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementtype rename(String name) {
        return new TCoreElementtype(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementtype rename(Name name) {
        return new TCoreElementtype(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementtype rename(Table<?> name) {
        return new TCoreElementtype(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementtype where(Condition condition) {
        return new TCoreElementtype(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementtype where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementtype where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementtype where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementtype where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementtype where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementtype where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementtype where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementtype whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementtype whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
